#include<stdio.h>
#include<stdlib.h>
extern int *halo[];
extern int *yhalo[];
extern int *nendhalo[];
extern int numhalo[];
extern int *ulinked_halo[];
extern int *dlinked_halo[];
extern int numulinked_halo[];
extern int numdlinked_halo[];
void link_slice_halo(int *halo1,int *tmpx,int *tmpy,int local_nz){
	int number,pixel_linked_halo[9];
	int i,ii,j,k;
	int mtmp,number,nend;
	int mx,my,kk,kkk;
	/*  This is up link halo searching 0<= i <= local_nz */
	for(i=0;i<=local_nz;i++){
		ii = i + 1; /* upper slice number */
		for(j=0;j<nx*ny;*(halo1+j++)=0){} /* initialize halo1 */
		for(j=0;j<numhalo[ii];j++)
			*(halo1 + *(xhalo[ii]+j)-1 + nx*(*(yhalo[ii]+j)-1)) = j + 1;
		/* *(xhalo[ii]+j)-1  ---> fortran orientation => c orientation
		 * *(yhalo[ii]+j)-1  ---> fortran orientation => c orientation
		 * *(xhalo[ii]) starts with 1.............................
		 */
		nend = 0;
		for(j=0;j<numhalo[i];j++){
			number = *(nendhalo[i]+j)-nend;
			mtmp = 0;
			for(k=0;k<number;k++){
				mx = *(xhalo[i]+nend+k)/* This is fortran orientation */
				my = *(yhalo[i]+nend+k)/* This is fortran orientation */
                /* fortran 
				 * pixel_linked_halo[0..8] indicates the halo number in upper
				 * slices......  == pixel_linked_halo(1:9) in fortran.
				 * */
				findlinkedhalo_(&mx,&my,&nx,&ny,halo1,pixel_linked_halo);
				for(kk=0;kk<9;kk++){
					if(pixel_linked_halo[kk] != 0){
						for(kkk=0;kkk<mtmp;kkk++){
							if(*(ulinked_halo[i]+kkk) == pixel_linked_halo[kk]){
								goto lbl444;
							}
						}
						mtmp = mtmp + 1;
						*(ulinked_halo[i]+mtmp) = pixel_linked_halo[kk];
lbl444:
					}
				}
			}
			nend = *(nendhalo[i]+j);
		}
		numulinked_halo[i] = mtmp;
	}
	/*  This is down link halo searching 1<= i <= local_nz+1 */
	for(i=1;i<=local_nz+1;i++){
		ii = i - 1;
		for(j=0;j<nx*ny;*(halo1+j++)=0){}
		for(j=0;j<numhalo[ii];j++)
			*(halo1 + *(xhalo[ii]+j)-1 + nx*(*(yhalo[ii]+j)-1)) = j + 1;
		nend = 0;
		for(j=0;j<numhalo[i];j++){
			number = *(nendhalo[i]+j)-nend;
			mtmp = 0;
			for(k=0;k<number;k++){
				mx = *(xhalo[i]+nend+k)
				my = *(yhalo[i]+nend+k)
				findlinkedhalo_(&mx,&my,halo1,pixel_linked_halo);
				for(kk=0;kk<9;kk++){
					if(pixel_linked_halo[kk] != 0){
						for(kkk=0;kkk<mtmp;kkk++){
							if(*(dlinked_halo[i]+kkk) == pixel_linked_halo[kk]){
								goto lbl555;
							}
						}
						mtmp = mtmp + 1;
						*(dlinked_halo[i]+mtmp) = pixel_linked_halo[kk];
lbl555:
					}
				}
			}
			nend = *(nendhalo[i]+j);
		}
		numdlinked_halo[i] = mtmp;
}
