#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>
#include <mpi.h>
#include "Memory.h"
#include "defs.h"
#define free(a) Free(a)
struct PeakPos{
	int x;
	int y;
	int z;
};
/*   ȮѴ.*/

extern int myrank,nrank;
/*    Ѵ. */
extern double onesolarmass;
extern double com2real,real2com,potentfact;
extern double pntmass;
extern double r1kineticfact,r2kineticfact;
extern float amax,a,rng,size,hubble;
extern int ng,nspace;
extern float omep,omeplam,acoeff[8];
extern float epsilon;
#include "header.h"
int Motherrank = motherrank;
extern float m_tidal[NUM_MASS],r_tidal[NUM_MASS];
struct PeakPos peak[MAX_PEAK_NUM];
/*
//extern lint *ptl2halonum;
*/
float *Tenergy;
lint *ppoint;
int mpeak;
extern float *den;
extern lint *den2ptl;
extern int magnitude;
float curmagnitude;
int mx,my,mz,nbuff;
float downhalovalue[MAX_PEAK_NUM];
int pvhalo_r[MAX_SURROUNDING_NUM];
int haloppoint[MAX_PEAK_NUM];
int numhaloseed[MAX_PEAK_NUM],endhaloseed[MAX_PEAK_NUM],endhalo[MAX_PEAK_NUM];
int *halo2res;
int numsubhalo;
lint *tmppoint;
lint stillfree_starting_number;
lint stillfree;
float sqrtepsilon;
int selfpotential=NO_EXIT;
void Ptidal(void){
}

void find_den(struct PtlPos *,lint ,int ,int ,int , float );
float find_curr_min_tidal_r(int ,float *,int ,int *,int);
void diff_force(int ,float *,float );
float w(float ,float );
void find_box_size(struct PtlPos *, lint ,float *,float *,
		float *,float *,float *,float *,float);
void indexx_(int *,float *,int *);
void integerindexx_(int *,int *,int *);
/*
void haloseed_(float *,int *,int *,int *, int *,int *,
		int *,int *,struct PeakPos *,int *,int *,float *,int *, int *,
		int *, int *,
		int *, int *, int *,int *);
		*/
void haloseed_();

void findpeak_(float *,int *,int *,int *,int *,struct PeakPos *,int *,
		float *);
#ifdef OLD_DEPTH
void treehaloparticle_(float *, int *,int *,int *,int *,int *,
		int *,int *,struct PeakPos *,int *,int *,float *,int *,int *,
		int *, int *,int *, int *,int *,int *,int *,
		int *,int *,int *,int *);
#else
void treehaloparticle_();
#endif

void kinetic_energy(struct PtlPos *,struct PtlVel *, float *,lint, 
		struct HaloPos *,struct HaloVel *,int );
void halo_properties(struct PtlPos *,struct PtlVel *,
		lint ,struct HaloPos *,struct HaloVel *,int );
void t_halo_properties(struct PtlPos *,struct PtlVel *,lint *,
		lint ,struct HaloPos *,struct HaloVel *);
void pick_up_vr_ptl(struct PtlPos *,struct PtlVel *, int ,
		int *,struct PtlPos *,struct PtlVel *,int );
void pick_up_r_ptl(struct PtlPos *,int ,int *, struct PtlPos *,int );
int num_pick_up_r_ptl(struct PtlPos *,int ,int *,struct PtlPos *,int );
float find_tidal_Rc(struct PtlPos *,lint ,struct PtlPos *,lint ,
		struct HaloPos *,struct HaloVel *,struct HaloPos *,
		struct HaloVel *,int,int);
float find_min_tidal_r(int, int ,float *,int *);
int workinclude(struct PtlPos *,struct PtlVel *,int ,
		lint *,lint *,struct PtlPos *,struct PtlVel *,
		lint ,int , struct HaloPos *,int ,float );
int pseudoinclude(struct PtlPos *,int ,int,struct PtlPos *,int *,int);
void many_halo(struct PtlPos *,struct PtlVel *,lint, 
		struct HaloPos *,struct HaloVel *,float ,float ,float , lint *,
		int, int *);
void alone_halo(struct PtlPos *,struct PtlVel *,lint ,
		struct HaloPos *,struct HaloVel *,float , float ,float , lint *,
		int, int *);
void Ppotential(int ,struct PtlPos *,lint *,struct PtlPos *,
		float *,lint ,int *,int ,int,int);
void potential(int ,struct PtlPos *,struct PtlPos *,
		float *,lint ,int *,int ,int);
#ifdef OLD_FOF
void fof_hfind(int ,struct PtlPos *,lint *,struct HaloPos *,int *,int );
#else
void fof_hfind(int ,struct PtlPos *,lint *,struct HaloPos *, int ,int );
#endif
int calculate_this(struct PtlPos *,struct PtlVel *,
		int ,int *,struct PtlPos *,struct PtlVel *,
		int ,int *,struct HaloPos *,float ,int *,int *,int);

#ifdef OLD_DEPTH
int swap2[NDEPTH*4];
#else
int NDEPTH;
int *swap2;
#endif
struct HaloPos seedhr[MAX_PEAK_NUM];
int subhalo_den(struct PtlPos *r,struct PtlVel *vr,indxtype *indx,
		lint np,float h,lint *ptl2halonum,int Parallel){
	int *swap;
	int i,j,k;
	int ix;
	int peakincluded[MAX_PEAK_NUM];
	char *included;
	int mtmppeak,numres;
	int mstep = NSTEP;
	int mxfortran,myfortran,mzfortran;
	int mtmpeak,nwidth;
	float width;
	float xinit,yinit,zinit,xmax,ymax,zmax;
	int nxinit,nyinit,nzinit,nxmax,nymax,nzmax;
	lint *pt2h;
	struct HaloPos hr[MAX_PEAK_NUM],*haloseedpos;
	struct HaloVel hvr[MAX_PEAK_NUM];
	FILE *fp1,*fp2,*fp3,*fp4;
	long membox;
	float magratio;
	int *peakxyz;

/*
	ppoint =  (lint *)malloc((np+1)*sizeof(lint));
*/
	/*
	ppoint =  Realloc(ppoint,(np+1)*sizeof(lint));
	*/
	ppoint =  Malloc((np+1)*sizeof(lint),PPTR(ppoint));
	/*    */
	find_box_size(r,np,&xinit,&yinit,&zinit,&xmax,&ymax,&zmax,h);
	curmagnitude = (float)magnitude;
	membox = (xmax-xinit)*(ymax-yinit)*(zmax-zinit)
		*magnitude*magnitude*magnitude;
#ifdef CHECK_INFORM
	fprintf(stderr," x = %g %g y = %g %g z= %g %g \n",
			xinit,xmax,yinit,ymax,zinit,zmax);
	fprintf(stderr,"current box size %ld and max. allow size is %d, pnum %d\n",membox,MAX_BOX_MEMORY,np);
#endif
	if(membox > MAX_BOX_MEMORY) {
		curmagnitude = (float)magnitude/
			pow(((float)membox)/((float)MAX_BOX_MEMORY),0.3333);
		magratio = magnitude/curmagnitude;
        fprintf(stderr,"magnification changed from %d to %g\n",
			magnitude,curmagnitude);
	}
	else magratio = 1.;
#ifdef CHECK_INFORM
	printf("allowed magnitude %d w.r.t. set magnitude\n",curmagnitude,magnitude);
#endif
	/*    */
	nxinit=floor(xinit-2.*h/curmagnitude);
	nyinit=floor(yinit-2.*h/curmagnitude);
	nzinit=floor(zinit-2.*h/curmagnitude);
	nxmax=ceil(xmax+2.*h/curmagnitude);
	nymax=ceil(ymax+2.*h/curmagnitude);
	nzmax=ceil(zmax+2.*h/curmagnitude);
	mx = (nxmax-nxinit+1)*curmagnitude;
	my = (nymax-nyinit+1)*curmagnitude;
	mz = (nzmax-nzinit+1)*curmagnitude;
	den =  Realloc(den,sizeof(float)*mx*my*mz);
	den2ptl =  Realloc(den2ptl,sizeof(lint)*mx*my*mz);
/*
	den =  Malloc(sizeof(float)*mx*my*mz,PPTR(den));
	den2ptl =  Malloc(sizeof(lint)*mx*my*mz,PPTR(den2ptl));
*/
	/*
	den =  (float *)malloc(sizeof(float)*mx*my*mz);
	den2ptl =  (int *)malloc(sizeof(lint)*mx*my*mz);
	*/
	find_den(r,np,nxinit,nyinit,nzinit,h);
#ifdef CHECK_INFORM
	printf("end of finding density at grid points\n");
#endif
	nbuff = ceil(2.*h);
	mxfortran = mx-2*nbuff;
	myfortran = my-2*nbuff;
	mzfortran = mz-2*nbuff;

/*
	peak = (struct PeakPos *) malloc(sizeof(struct PeakPos)*MAX_PEAK_NUM);
*/
	findpeak_(den,&nbuff,&mxfortran,&myfortran,&mzfortran,peak,&mpeak,
		&magratio);
#ifdef CHECK_INFORM
	printf("end of finding density peaks : %d\n",mpeak);
#endif
	{
		int ntmp,ntmp2;
/*
		seedhr = (struct HaloPos *)malloc(sizeof(struct HaloPos)*mpeak);
*/
		for(i=0;i<mpeak;i++){
			ntmp = *(den2ptl+peak[i].x+nbuff-1+mx*(peak[i].y+nbuff-1)+
					mx*my*(peak[i].z+nbuff-1));
			ntmp2 = 0;
			seedhr[i].x = 0; seedhr[i].y = 0; seedhr[i].z = 0;
			while(ntmp != 0){
				seedhr[i].x += r[ntmp-1].x;
				seedhr[i].y += r[ntmp-1].y;
				seedhr[i].z += r[ntmp-1].z;
				ntmp2++;
				ntmp = ppoint[ntmp-1];
			}
#ifdef CHECK_INFORM
	printf("number of seed particles : %d\n",ntmp2);
#endif
			seedhr[i].x /= ntmp2;
			seedhr[i].y /= ntmp2;
			seedhr[i].z /= ntmp2;
			/*
		printf("%g %d :",*(den+peak[i].x+nbuff-1+mx*(peak[i].y+nbuff-1)+
					                    mx*my*(peak[i].z+nbuff-1)),ntmp2);
		printf("%g %g %g\n",seedhr[i].x,seedhr[i].y,seedhr[i].z);fflush(stdout);
		*/
		}
	}

	/* ⼭ʹ haloseed   ޸𸮸 . */
	/* downhalovalue = Ϸ seed  density threshold ̴Ã.
	 * haloppoint    = ش Ϸο ԵǾ ִ ڵ Ű
	 *                 linked-list ̴.
	 * numhaloseed   = Ϸ seed  ԵǾ ִ  ̴.
	 * endhaloseed   =  ڸ Ű 
	 * endhalo       = Ϸ  Ų.  
	 * ߿ : Ʈ  ؼ ppoint(i) 
	 * i°  (0  ϴ) Ű ...  (ppoint(i)-1) 
	 *   ġ ȴ. */
	included = (char *) Calloc(mx*my*mz,sizeof(char),PPTR(included));
/*
	included = Realloc(included,mx*my*mz*sizeof(int));
	peakincluded = (int *) Calloc(MAX_PEAK_NUM,sizeof(int));
	haloppoint = (int *) Calloc(MAX_PEAK_NUM,sizeof(int));
	endhaloseed = (int *) Calloc(MAX_PEAK_NUM,sizeof(int));
	pvhalo_r = (int *) Calloc(MAX_SURROUNDING_NUM,sizeof(int));
	downhalovalue = (float *) Calloc(MAX_PEAK_NUM,sizeof(float));
	numhaloseed = (int *) Calloc(MAX_PEAK_NUM,sizeof(int));
	endhalo = (int *) Calloc(MAX_PEAK_NUM,sizeof(int));
*/
	if(mpeak > 0){
#ifdef CHECK_INFORM
	printf("entering into haloseed_ with parallel value %d\n",Parallel);
#endif
#ifndef OLD_DEPTH
	NDEPTH = (mxfortran+1)*(myfortran+1)*(mzfortran+1);
	swap2 = (int *)Malloc(NDEPTH*sizeof(int),PPTR(swap2));
	peakxyz = (int *)Malloc(sizeof(int)*mpeak,PPTR(peakxyz));
#endif
	haloseed_(den,den2ptl,&nbuff,&mxfortran,&myfortran,&mzfortran,
			ppoint,&np,peak,&mpeak,peakxyz,
			haloppoint,downhalovalue,numhaloseed,
			endhaloseed,included,peakincluded,&Parallel,
			&myrank,&Motherrank,&nrank,
#ifdef OLD_DEPTH
			swap2,swap2+NDEPTH,swap2+2*NDEPTH,
			swap2+3*NDEPTH
#else
			swap2

#endif
	);
#ifndef OLD_DEPTH
	Free(peakxyz);
	Free(swap2);
#endif
#ifdef CHECK_INFORM
	printf("end of haloseed\n");
#endif
	mtmppeak = 0;
	i = 0;
	while(i < mpeak){
		if(numhaloseed[i] >= MIN_HALO_SEED_NUM){
#ifdef CHECK_INFORM
			printf("%d %d %d in peak num %d\n",peak[i].x,peak[i].y,peak[i].z,mpeak);fflush(stdout);
#endif
			numhaloseed[mtmppeak] = numhaloseed[i];
			peak[mtmppeak].x = peak[i].x;
			peak[mtmppeak].y = peak[i].y;
			peak[mtmppeak].z = peak[i].z;
			haloppoint[mtmppeak] = haloppoint[i];
			downhalovalue[mtmppeak] = downhalovalue[i];
			endhalo[mtmppeak] = endhalo[i];
			endhaloseed[mtmppeak] = endhaloseed[i];
			if(i != mtmppeak) numhaloseed[i] = 0;
			mtmppeak++;
		}
		i++;
	}
	mpeak = mtmppeak;
#ifdef CHECK_INFORM
	fprintf(stdout,"%d peaks are detected\n",mpeak);
#endif
		if(mpeak == 0) {
			/*
//			free(den);free(den2ptl);
//			*/
/*
			free(ppoint);
			free(haloppoint);
			free(endhaloseed);
			free(pvhalo_r);
			free(downhalovalue);
			free(numhaloseed);
			free(endhalo);
			free(peakincluded);
			free(peak);
*/
			Free(included);
			return 0;
		}
		j = 0;
		/* ⼭ ʹ haloseed  Ե ڸ  ̴. */
		for(i=0;i<mpeak;i++){
			if(numhaloseed[i] >= MIN_HALO_SEED_NUM) j++;
		}
		if(j == 0) {
			/*
//			free(den);free(den2ptl);
//			*/
/*
			free(ppoint);
			free(haloppoint);
			free(pvhalo_r);
			free(endhaloseed);
			free(downhalovalue);
			free(numhaloseed);
			free(endhalo);
			free(peakincluded);
			free(peak);
*/
			Free(included);
			return 0;
		}
/*************************************************************************/
/*
		find_den(r,np,nxinit,nyinit,nzinit,h);
		haloseed_(den,den2ptl,&nbuff,&mxfortran,&myfortran,&mzfortran,
				ppoint,&np,peak,&mpeak,
				haloppoint,downhalovalue,numhaloseed,
				endhaloseed,included,peakincluded);
*/
/*************************************************************************/
		numres = 0;
 	 	halo2res = (int *) Malloc(sizeof(int)*mstep*mpeak,PPTR(halo2res));
		for(i=0;i<mstep*mpeak;i++) halo2res[i] = 0;
		if(j >= 2){
#ifndef OLD_DEPTH
			NDEPTH = (mxfortran+1)*(myfortran+1)*(mzfortran+1);
			swap2 = (int *)Malloc(sizeof(int)*NDEPTH,PPTR(swap2));
#endif
			treehaloparticle_(den,den2ptl,&nbuff,&mxfortran,&myfortran,
					&mzfortran,&np,ppoint,peak,&mpeak,haloppoint,
					downhalovalue,numhaloseed,endhaloseed,endhalo,
					&numsubhalo,halo2res,&mstep,included,
					peakincluded,pvhalo_r,
#ifdef OLD_DEPTH
					swap2,swap2+NDEPTH,swap2+2*NDEPTH,
					swap2+3*NDEPTH
#else
					swap2
#endif
					);
#ifndef OLD_DEPTH
			Free(swap2);
#endif
#ifdef CHECK_INFORM
			fprintf(stdout,"Now I am out of treehaloparticle_\n");
#endif
		}
		/* downhalovalue  haloseed  عٴ Ϸ е
		 * halo2res[i,j]  i ° Ϸ j ° е ܰ谡 Ű
		 * pvhalo_r  ̴.
		 * pvhalo_r   linked-list  Ų.  */
		/*
		save_residual();
		*/
	}
	/*
//	free(den);free(den2ptl);
//	*/
#ifdef CHECK_INFORM
	fprintf(stdout,"Now I have %d peaks and %d particles\n",mpeak,np);
#endif
	for(i=0;i<np;i++) {
		ppoint[i] = ppoint[i]-1;
		if(ppoint[i]<0) ppoint[i] = NO_EXIT;
	}
	for(i=0;i<mpeak*mstep;i++){
		halo2res[i] = halo2res[i]-1;
		if(halo2res[i]<0) halo2res[i] = NO_EXIT;
	}
	for(i=0;i<numsubhalo;i++){
		pvhalo_r[i] = pvhalo_r[i] - 1;
		if(pvhalo_r[i] < 0) pvhalo_r[i] = NO_EXIT;
	}
	for(i=0;i<mpeak;i++){
		haloppoint[i] = haloppoint[i] - 1;
		if(haloppoint[i] < 0)haloppoint[i] = NO_EXIT;
	}

	NODE_NUM_SIZE =  NODE_SIZE * np *NODE_BUFFER;
	NODE_SIZE_STRIDE = np*NODE_BUFFER;
	swap = (int *)Malloc(sizeof(int)*NODE_NUM_SIZE,PPTR(swap));
	tmppoint = (lint *)Malloc(sizeof(lint)*np,PPTR(tmppoint));
	/*
	physical_parameters();
	*/
	/* in this paragraph, haloseedpos inidcates the seed posiiton */
	/*
	hr = (struct HaloPos *)malloc(sizeof(struct HaloPos)*mpeak);
	hvr = (struct HaloVel *)malloc(sizeof(struct HaloVel)*mpeak);
	hr = (struct HaloPos *)malloc(sizeof(struct HaloPos)*MAX_PEAK_NUM);
	hvr = (struct HaloVel *)malloc(sizeof(struct HaloVel)*MAX_PEAK_NUM);
	*/
	if(mpeak == 1){
#ifdef CHECK_INFORM
		fprintf(stdout,"Entering alone_halo\n");
#endif
		alone_halo(r,vr,np,hr,hvr,xinit,yinit,zinit,ptl2halonum,
				Parallel,swap);
#ifdef CHECK_INFORM
		fprintf(stdout,"exiting from alone_halo\n");
#endif
#ifdef OLD_FOF
		fof_hfind(np,r,ptl2halonum,seedhr,swap,NODE_SIZE_STRIDE);
#else
		fof_hfind(np,r,ptl2halonum,seedhr,0,Parallel);
#endif
#ifdef CHECK_INFORM
		fprintf(stdout,"after fof_hfind alone_halo\n");
#endif
	}
	else if(mpeak > 1){
#ifdef CHECK_INFORM
		printf("%d peaks with Parallel value %d ",mpeak,Parallel); fflush(stdout);
#endif
		many_halo(r,vr,np,hr,hvr,xinit,yinit,zinit,ptl2halonum,
				Parallel,swap);
#ifdef CHECK_INFORM
		printf("now before final fof\n "); fflush(stdout);
#endif
#ifdef OLD_FOF
		fof_hfind(np,r,ptl2halonum,seedhr,swap,NODE_SIZE_STRIDE);
#else
		fof_hfind(np,r,ptl2halonum,seedhr,0,Parallel);
#endif
#ifdef CHECK_INFORM
		printf("now closing final fof\n "); fflush(stdout);
#endif
	}
	

	if(ppoint != NULL) Free(ppoint);
	if(tmppoint != NULL) Free(tmppoint);
  	if(swap != NULL) Free(swap);
	if(included != NULL) Free(included);
/*
	if(ppoint != NULL) free(ppoint);
	if(peak != NULL) free(peak);
	if(hr != NULL) free(hr);
	if(hvr != NULL) free(hvr);
	if(peakincluded != NULL) free(peakincluded);
	if(haloppoint != NULL) free(haloppoint); 
	if(numhaloseed != NULL) free(numhaloseed);
	if(endhaloseed != NULL) free(endhaloseed); 
	if(endhalo != NULL) free(endhalo); 
*/
	return mpeak;
}
/*  tr,tvr,tnp  ü ڸ Ÿ,
 *  r,vr,np    ڸ Ÿ.  */
int *cur2thalonum;
void many_halo(struct PtlPos *tr,struct PtlVel *tvr,lint tnp,
		struct HaloPos *hr,struct HaloVel *hvr,
		float xinit,float yinit,float zinit,lint *ptl2halonum,
		int Parallel,int *swap){
	lint *hhasptl;
	lint i,j,k,ix;
	float *tidal_Rc;
	lint *pt2h,*ptl2tptl;
	lint ntmp,ntmp2,ntmp3;
	struct PtlPos *largehalor,*smallhalor,*r;
	struct PtlVel *largehalovr,*smallhalovr,*vr;
	float *kinetic,*potent;
	int lnp,snp;
	int ii,jj;

    int *idx,*inidx,*curhasptl;
	lint *respnum;
	float min_tidal_r;

	int ready,*proc2tidal,state;
	int numsend,numrecv;
	float tmp_tidal;
	MPI_Status cstatus;
	float *min_tidal_R;
	float *omin_tidal_R;



	pt2h = ptl2halonum;
	hhasptl = (lint *)Malloc(sizeof(lint)*mpeak,PPTR(hhasptl));
	tidal_Rc = (float *)Malloc(sizeof(float)*mpeak*mpeak,PPTR(tidal_Rc));
	cur2thalonum = (int *) Malloc(sizeof(int)*mpeak,PPTR(cur2thalonum));
	for(i=0;i<mpeak*mpeak;i++) *(tidal_Rc) = 0.;
	/*
//	pt2h = (lint *)malloc(sizeof(lint)*tnp);
//	*/
	kinetic = (float *)Malloc(sizeof(float)*tnp,PPTR(kinetic));
	respnum = (lint *)Malloc(sizeof(lint)*numsubhalo,PPTR(respnum));
	stillfree = NO_EXIT;
	for(i=0;i<numsubhalo;i++){
		ntmp = 0;
		ntmp2 = pvhalo_r[i];
		while(ntmp2!=NO_EXIT){
			ntmp++;
			ntmp2 = ppoint[ntmp2];
		}
		respnum[i] = ntmp;
	}
	/* ̰ 꿡   haloseed  ڵ鸸  ش Ϸ
	 *  ϱ ̴.  */
	for(i=0;i<tnp;i++) pt2h[i] = NOT_HALO_MEMBER;
#ifdef CHECK_INFORM
	printf("now I am in many halo with %d peaks",mpeak);fflush(stdout);
#endif
	for(i=0;i<mpeak;i++){
		ntmp = haloppoint[i];
		ntmp2 = 0;
		while(ntmp != NO_EXIT){
			pt2h[ntmp] = i;
			ntmp = ppoint[ntmp];
			ntmp2++;
		}
		hhasptl[i] = ntmp2;
#ifdef CHECK_INFORM
		printf(".");fflush(stdout);
#endif
	}
	/* ⼭ pvhalo_r  . */
	idx = (lint *)Malloc(sizeof(lint)*mpeak,PPTR(idx));
	inidx = (lint *)Malloc(sizeof(lint)*mpeak,PPTR(inidx));
	curhasptl = (lint *)Malloc(sizeof(lint)*mpeak,PPTR(curhasptl));
	smallhalor = (struct PtlPos *)Malloc(sizeof(struct PtlPos)*tnp,
			PPTR(smallhalor));
	smallhalovr = (struct PtlVel *)Malloc(sizeof(struct PtlVel)*tnp,
			PPTR(smallhalovr));
	ptl2tptl = (lint *)Malloc(tnp*sizeof(lint),PPTR(ptl2tptl));
	Tenergy = (float *)Malloc(sizeof(float)*tnp,PPTR(Tenergy));
	largehalor = (struct PtlPos *)Malloc(sizeof(struct PtlPos)*tnp,
			PPTR(largehalor));
	selfpotential = 0;
	/*   peak  ڰ , ķ  ؾѴٸ,
	 *  ü   ϰ, ߿ ̰  Ѵ. */
	if(mpeak >=SCATTER_TIDAL_CAL && Parallel != 0){
		proc2tidal = (int *) Calloc(mpeak*mpeak,sizeof(int),PPTR(proc2tidal));
		for(i=1;i<nrank;i++){
			MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,READY,
					MPI_COMM_WORLD,&cstatus);
			ready = INIT_TOTAL_PARTICLE_BCAST;
			MPI_Send(&ready,1,MPI_INT,cstatus.MPI_SOURCE,0,
					MPI_COMM_WORLD);
		}
		MPI_Bcast(&tnp,1,MPI_INT,motherrank,MPI_COMM_WORLD);
		MPI_Bcast(tr,3*tnp,MPI_FLOAT,motherrank,MPI_COMM_WORLD);
	}
	for(k=0;k<numsubhalo;k++){
#ifdef CHECK_INFORM
		fprintf(stderr,"Entering numsubhalo %d in %d\n",k,numsubhalo);
#endif
		r = tr; vr = tvr;
   		t_halo_properties(r,vr,pt2h,tnp,hr,hvr);
		/* curhasptl    Ϸ  ̴. */
		ntmp = 0;
		for(i=0;i<mpeak;i++){
			/*
			if(*(halo2res+i+k*mpeak) != NO_EXIT){
			if(*(halo2res+i+k*NSTEP) != NO_EXIT){
                                curhasptl[ntmp] = hhasptl[i];
                                cur2thalonum[ntmp] = i;
                                ntmp++;
			}
			*/
                        for(ii=0;ii<NSTEP;ii++){
				if(*(halo2res+i+ii*mpeak) == k) {
                                        curhasptl[ntmp] = hhasptl[i];
                                        cur2thalonum[ntmp] = i;
                                        ntmp++;
                                }

			}
		}
		integerindexx_(&ntmp,curhasptl,idx);
		for(i=0;i<ntmp;i++) idx[i] -= 1;
		/* i Ϸο   j Ϸ tidal radius   tidal_Rc[j,i] */
		/*
		for(i=0;i<mpeak*mpeak;i++) tidal_Rc[i] = 0.;
		*/
		/* ࿡ Ϸΰ  ų  μ  ۾ϻ  */
		if(ntmp < SCATTER_TIDAL_CAL || Parallel == 0){
			for(ii=0;ii<ntmp;ii++){
				i = cur2thalonum[idx[ii]];
				pick_up_r_ptl(largehalor,i,pt2h,tr,tnp);
				for(jj=0;jj<ii;jj++){
					j = cur2thalonum[idx[jj]];
					if(hhasptl[i] >= hhasptl[j] && i!=j){
						/*
						pick_up_r_ptl(smallhalor,j,pt2h,tr,tnp);
						*/						
						*(tidal_Rc+j+i*mpeak) = 
								find_tidal_Rc(largehalor,hhasptl[i],
									smallhalor,hhasptl[j],hr+j,hvr+j,hr+i,hvr+i,
									Parallel,0);
					}
				}
			}
#ifdef CHECK_INFORM
			fprintf(stderr,"After tidal calculation  numsubhalo %d in %d\n",k,numsubhalo);
#endif
		}
		/***************************************************************/
		/*Ϸΰ ʹ ,   ؾ Ҷ */
		else {
			for(i=1;i<nrank;i++){
				MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,READY,
						MPI_COMM_WORLD,&cstatus);
				ready = TOTAL_PARTICLE_BCAST;
				MPI_Send(&ready,1,MPI_INT,cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD);
			}
			/*
			MPI_Bcast(&tnp,1,MPI_INT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(tr,3*tnp,MPI_FLOAT,motherrank,MPI_COMM_WORLD);
			*/
			MPI_Bcast(pt2h,tnp,MPI_INT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(&mpeak,1,MPI_INT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(hr,3*mpeak,MPI_INT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(hvr,3*mpeak,MPI_FLOAT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(hhasptl,mpeak,MPI_INT,motherrank,MPI_COMM_WORLD);
			numsend = numrecv = 0;
			/*
//			proc2tidal = (int *) Calloc(mpeak*mpeak,sizeof(int));
//			*/
			for(ii=0;ii<ntmp;ii++){
				i = cur2thalonum[idx[ii]];
				for(jj=0;jj<ii;jj++){
					j = cur2thalonum[idx[jj]];
					if(hhasptl[i] >= hhasptl[j] && i!=j){
						do{
							MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,
									MPI_ANY_TAG,MPI_COMM_WORLD,&cstatus);
							if(ready == READY){
								proc2tidal[cstatus.MPI_SOURCE] = 
									j + mpeak * i;
								state = ParallelTidal;
								MPI_Send(&state,1,MPI_INT,cstatus.MPI_SOURCE,
										0,MPI_COMM_WORLD);
								MPI_Send(&i,1,MPI_INT,cstatus.MPI_SOURCE,
										0,MPI_COMM_WORLD);
								MPI_Send(&j,1,MPI_INT,cstatus.MPI_SOURCE,
										0,MPI_COMM_WORLD);
								numsend ++;
							}
							else if(ready == Tidal_Report){
								MPI_Recv(&tmp_tidal,1,MPI_FLOAT,
										cstatus.MPI_SOURCE,0,MPI_COMM_WORLD,
										&cstatus);
								tidal_Rc[proc2tidal[cstatus.MPI_SOURCE]]
									= tmp_tidal;
								numrecv ++;
							}
						}while(ready != READY);
					}
				}
			}
	        for(i=numrecv;i<numsend;i++){
				MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,Tidal_Report,
						MPI_COMM_WORLD, &cstatus);
				MPI_Recv(&tmp_tidal,1,MPI_FLOAT,cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD,&cstatus);
				tidal_Rc[proc2tidal[cstatus.MPI_SOURCE]] = tmp_tidal;
			}
			for(i=1;i<nrank;i++){
				MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,READY,MPI_COMM_WORLD,
						&cstatus);
				ready = FREE_IN_TIDAL;
				MPI_Send(&ready,1,MPI_INT,cstatus.MPI_SOURCE,0,MPI_COMM_WORLD);
			}
		}
		/***************************************************************/
		for(i=0;i<ntmp;i++){
#ifdef CHECK_INFORM
			fprintf(stderr,"no potential %d in %d halo\n",i,ntmp);
#endif
			ii = cur2thalonum[idx[i]];
			/* pseudoinclude   Ȯ ڵ Ʒ residual  ִ
			 * ڵ   ִ´ */
			lnp = pseudoinclude(largehalor,ii,k,tr,pt2h,tnp);
			/* workinclude   ۾ϴ  residual  ִ ڸ 
			 * Ѵ.  Ѱ Ұ ptl2tptl  ؼ 
			 * ۾Ѵ ڰ ü   ϴ ̴. */
			min_tidal_r = find_curr_min_tidal_r(ii,tidal_Rc,i,idx,ntmp);
			snp = workinclude(smallhalor,smallhalovr,k,ptl2tptl,pt2h,tr,tvr,
					tnp,ii,hr,ii,min_tidal_r);
			/*
			halo_properties(smallhalor,smallhalovr,snp,hr,hvr,ii);
			*/
			kinetic_energy(smallhalor,smallhalovr,kinetic,snp,hr,hvr,ii);
			/* ü  ؼ  ڸ 󳽴. 
			 */
			/*
			for(j=0;j<snp;j++) Tenergy[j] = 0.;
			*/
/*
			if(snp > 0) potential(snp,smallhalor,tmppoint,largehalor,Tenergy,
*/
			if(snp > 0) potential(snp,smallhalor,largehalor,Tenergy,
					lnp,swap,NODE_SIZE_STRIDE,Parallel);
			for(j=0;j<snp;j++) Tenergy[j] = Tenergy[j]+kinetic[j];
			for(j=0;j<snp;j++){
			   	if(Tenergy[j] < 0.){
			   		pt2h[ptl2tptl[j]] = ii;		
			   	}
				else {
					pt2h[ptl2tptl[j]] = NOT_HALO_MEMBER;
				}
			}
		}
		/* stillfree ٰ  residual  Ե  ڸ ִ´. */
		ntmp = stillfree;
		ntmp2 = pvhalo_r[k];
		while(ntmp2 != NO_EXIT){
			if(pt2h[ntmp2] == NOT_HALO_MEMBER){
				stillfree = ntmp2;
				ntmp3 = ppoint[ntmp2];
				ppoint[ntmp2] = ntmp;
				ntmp = ntmp2;
			}
			else{
				ntmp3 = ppoint[ntmp2];
			}
			ntmp2 = ntmp3;
		}
		/*
		for(i=0;i<stillfree_starting_number ;i++){
			if(Tenergy[i] >= 0){
				stillfree = ptl2tptl[i];
				ppoint[ptl2tptl[i]] = ntmp;
				ntmp = ptl2tptl[i];
			}
		}
		*/
		/*  ̹ ܰ迡 Ϸ   Ʈ Ѵ. */
		for(i=0;i<mpeak;i++) hhasptl[i] = 0;
		for(i=0;i<tnp;i++){
			if(pt2h[i] >= 0) hhasptl[pt2h[i]]++;
		}
#ifdef CHECK_INFORM
		printf("end of numsubhalo %d\n",numsubhalo);fflush(stdout);
#endif
	}
	selfpotential = 1;
	/*  haloseed  Ǿ ִ ڴ  Ϸο ٽ  ִ´. */
	for(i=0;i<mpeak;i++){
		ntmp = haloppoint[i];
		while(ntmp != NO_EXIT){
			pt2h[ntmp] = i;
			ntmp = ppoint[ntmp];
		}
	}
	/*   FoF  ؼ ϴ ʿ ͸ ̴´. */
	r = tr;vr= tvr;
	t_halo_properties(r,vr,pt2h,tnp,hr,hvr);
#ifdef OLD_FOF
	fof_hfind(tnp,tr,pt2h,hr,swap,NODE_SIZE_STRIDE);
#else
	fof_hfind(tnp,tr,pt2h,hr,0,Parallel);
#endif
#ifdef CHECK_INFORM
	fprintf(stdout,"Now after fof\n");fflush(stdout);
#endif
	Free(halo2res);
	/* ⼭ ʹ ü ټ Ͽ ٽ Ѵ. */
	min_tidal_R = (float *) Malloc(sizeof(float)*mpeak,PPTR(min_tidal_R));
	omin_tidal_R = (float *) Malloc(sizeof(float)*mpeak,
			PPTR(omin_tidal_R));
	for(i=0;i<mpeak;i++) min_tidal_R[i] = 9999999.;
	for(k=0;k<BOUND_ITER;k++){ 
	/*  haloseed  Ǿ ִ ڴ  Ϸο ٽ  ִ´. */
		for(i=0;i<mpeak;i++){
			ntmp = haloppoint[i];
			while(ntmp != NO_EXIT){
				pt2h[ntmp] = i;
				ntmp = ppoint[ntmp];
			}
		}
		r = tr;vr= tvr;
		t_halo_properties(r,vr,pt2h,tnp,hr,hvr);
#ifdef CHECK_INFORM
	fprintf(stdout,"in BOUND_ITER after t_halo_properties\n");
#endif
		/*i Ϸο   j Ϸ tidal radius   tidal_Rc[j,i]*/
		for(i=0;i<mpeak;i++){
			hhasptl[i] = 0;
		}
		for(i=0;i<tnp;i++){
			if(pt2h[i] >= 0) hhasptl[pt2h[i]]++;
		}
		for(i=0;i<mpeak*mpeak;i++) tidal_Rc[i] = 9999999.;
		integerindexx_(&mpeak,hhasptl,idx);
		for(j=0;j<mpeak;j++) idx[j] -= 1;
		for(j=0;j<mpeak;j++) inidx[idx[j]] = j;
		/*࿡ Ϸΰ  ų  μ  ۾ϻ  */
		if(((mpeak < SCATTER_TIDAL_CAL || Parallel == 0))){
			for(i=0;i<mpeak;i++) omin_tidal_R[i] = min_tidal_R[i];
			for(i=0;i<mpeak;i++) min_tidal_R[i] = 9999999.;
			for(i=0;i<mpeak;i++){
				pick_up_r_ptl(largehalor,i,pt2h,tr,tnp);
				for(j=0;j<mpeak;j++){
					if(hhasptl[i] >= hhasptl[j] && i!=j){
						/*
						pick_up_r_ptl(smallhalor,j,pt2h,tr,tnp);
						*/
						*(tidal_Rc+j+i*mpeak) = 
							find_tidal_Rc(largehalor,hhasptl[i],
								smallhalor,hhasptl[j],hr+j,hvr+j,hr+i,hvr+i,
								Parallel,0);
						min_tidal_R[j] = MIN(min_tidal_R[j],*(tidal_Rc+j+i*mpeak));
					}
				}
			}
			for(i=0;i<mpeak;i++){
				if(omin_tidal_R[i]< 9999999. && 
					min_tidal_R[i] < omin_tidal_R[i]) {
					min_tidal_R[i] = omin_tidal_R[i];
				}
			}
#ifdef CHECK_INFORM
		fprintf(stdout,"Now after tidal-R: %d\n",k);fflush(stdout);
#endif
		}
		/***************************************************************/
		/*Ϸΰ ʹ ,   ؾ Ҷ */
		/* this routine has some problem.. but above same routine is right. 
		 * but now it doesn't executed because of large number of 
		 * SCATTER_TIDAL_CAL  2001. 11. 28.*/
		else {
			for(i=1;i<nrank;i++){
				MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,READY,
						MPI_COMM_WORLD,&cstatus);
				ready = TOTAL_PARTICLE_BCAST;
				MPI_Send(&ready,1,MPI_INT,cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD);
			}
			/*
			MPI_Bcast(&tnp,1,MPI_INT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(tr,3*tnp,MPI_FLOAT,motherrank,MPI_COMM_WORLD);
			*/
			MPI_Bcast(pt2h,tnp,MPI_INT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(&mpeak,1,MPI_INT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(hr,3*mpeak,MPI_INT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(hvr,3*mpeak,MPI_FLOAT,motherrank,MPI_COMM_WORLD);
			MPI_Bcast(hhasptl,mpeak,MPI_INT,motherrank,MPI_COMM_WORLD);
			numsend = numrecv = 0;
			for(i=0;i<mpeak;i++){
				for(j=0;j<mpeak;j++){
					if(hhasptl[i] >= hhasptl[j] && i!=j){
						do{
							MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,
									MPI_ANY_TAG,MPI_COMM_WORLD,&cstatus);
							if(ready == READY){
								proc2tidal[cstatus.MPI_SOURCE] = 
									j + mpeak * i;
								state = ParallelTidal;
								MPI_Send(&state,1,MPI_INT,cstatus.MPI_SOURCE,
										0,MPI_COMM_WORLD);
								MPI_Send(&i,1,MPI_INT,cstatus.MPI_SOURCE,
										0,MPI_COMM_WORLD);
								MPI_Send(&j,1,MPI_INT,cstatus.MPI_SOURCE,
										0,MPI_COMM_WORLD);
								numsend ++;
							}
							else if(ready == Tidal_Report){
								MPI_Recv(&tmp_tidal,1,MPI_FLOAT,
										cstatus.MPI_SOURCE,0,MPI_COMM_WORLD,
										&cstatus);
								tidal_Rc[proc2tidal[cstatus.MPI_SOURCE]]
									= tmp_tidal;
								numrecv ++;
							}
						}while(ready != READY);
					}
				}
			}
	        for(i=numrecv;i<numsend;i++){
				MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,Tidal_Report,
						MPI_COMM_WORLD, &cstatus);
				MPI_Recv(&tmp_tidal,1,MPI_FLOAT,cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD,&cstatus);
				tidal_Rc[proc2tidal[cstatus.MPI_SOURCE]] = tmp_tidal;
			}
			/*
			for(i=1;i<nrank;i++){
				MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,READY,MPI_COMM_WORLD,
						&cstatus);
				ready = FREE_IN_TIDAL;
				MPI_Send(&ready,1,MPI_INT,cstatus.MPI_SOURCE,0,MPI_COMM_WORLD);
			}
			*/
		}
/*
		}
*/
		/**************************************************************/
		for(j=0;j<mpeak;j++){
#ifdef CHECK_INFORM
			fprintf(stdout,"Now halo of %d: %d",j,k);fflush(stdout);
#endif
			ii = idx[j];
/*
			min_tidal_r = find_min_tidal_r(j,ii,tidal_Rc,idx);
*/
			min_tidal_r = min_tidal_R[ii];
			/*  ҴǾ ִ ڸ  . */
			lnp = num_pick_up_r_ptl(largehalor,ii,pt2h,tr,tnp);
			if(lnp == 0) continue;
#ifdef CHECK_INFORM
			fprintf(stdout,"pick up # %d of halo %d",lnp,ii);fflush(stdout);
#endif
/*
			fprintf(stderr,"%d has %g tidal R\n",lnp,min_tidal_r);
			fflush(stderr);
*/
			/*  Ϸο Ҵ Ǿ  ʰ, 
		  	 *	 Ϸο ҴǾ 
			 * ִ ڵ(r< min_tidal_r  󳽴.) */
			snp = calculate_this(smallhalor,smallhalovr,ii,
					pt2h,tr,tvr,tnp,
					ptl2tptl,hr, min_tidal_r,idx,inidx,j);
#ifdef CHECK_INFORM
			fprintf(stdout,"calcul.  # %d \n",snp);fflush(stdout);
#endif
			kinetic_energy(smallhalor,smallhalovr,kinetic,snp,hr,hvr,ii);
#ifdef CHECK_INFORM
			fprintf(stdout,"calculated kinetic  \n");fflush(stdout);
#endif
			/*
			for(i=0;i<snp;i++) Tenergy[i] = 0.;
			*/
			if(snp > 0) {
/*
				potential(snp,smallhalor,tmppoint,largehalor,Tenergy,
*/
				potential(snp,smallhalor,largehalor,Tenergy,
					lnp,swap,NODE_SIZE_STRIDE,Parallel);
#ifdef CHECK_INFORM
				fprintf(stdout,"calculated potential  \n");fflush(stdout);
#endif
				for(i=0;i<snp;i++){
				   	if(Tenergy[i] < 0.){
				   		pt2h[ptl2tptl[i]] = ii;		
				   	}
					else if(pt2h[ptl2tptl[i]] == ii) {
						pt2h[ptl2tptl[i]] = NOT_HALO_MEMBER;
					}
				}
			}
		}
	}
#ifdef CHECK_INFORM
	fprintf(stdout,"Now end of BOUND_ITER\n");fflush(stdout);
#endif
	t_halo_properties(r,vr,pt2h,tnp,hr,hvr);
#ifdef CHECK_INFORM
	fprintf(stdout,"Now just end of\n");fflush(stdout);
#endif
	/*  peak  ڰ , İ̾ٸ, ʱ Ÿ ϵ
	 * Ѵ. */
	if(mpeak >= SCATTER_TIDAL_CAL && Parallel != 0){
		for(i=1;i<nrank;i++){
			/*
			MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,READY,MPI_COMM_WORLD,
					&cstatus);
			ready = FREE_INITIAL_TIDAL;
			MPI_Send(&ready,1,MPI_INT,cstatus.MPI_SOURCE,0,MPI_COMM_WORLD);
			*/
			MPI_Recv(&ready,1,MPI_INT,i,READY,MPI_COMM_WORLD,
					&cstatus);
			ready = FREE_INITIAL_TIDAL;
			MPI_Send(&ready,1,MPI_INT,i,0,MPI_COMM_WORLD);
		}
		Free(proc2tidal);
	}
  	Free(hhasptl);Free(tidal_Rc);Free(respnum);
	Free(idx);Free(inidx);Free(curhasptl);Free(smallhalor);
	Free(smallhalovr);Free(ptl2tptl);Free(Tenergy);Free(largehalor);
	Free(kinetic);
	Free(cur2thalonum);

 	Free(min_tidal_R); Free(omin_tidal_R);
#ifdef CHECK_INFORM
	fprintf(stdout,"Now out of many_halo\n");fflush(stdout);
#endif
}
/* α׷ i Ϸθ Ű ڵ ̾Ƴ r  ϴ ̴. */
int num_pick_up_r_ptl(struct PtlPos *a,int haloindex,int *pt2h,
		struct PtlPos *tr,int tnp){
	int i,ntmp;
	ntmp = 0;
	for(i=0;i<tnp;i++){
		if(pt2h[i] == haloindex){
			a[ntmp].x = tr[i].x;
			a[ntmp].y = tr[i].y;
			a[ntmp].z = tr[i].z;
			ntmp++;
		}
	}
	return ntmp;
}
/*  alone_halo  potential  parameter  ٽ ľ Ѵ. */
int calculate_this(struct PtlPos *r,struct PtlVel *vr,
		int ii,int *pt2h,struct PtlPos *tr,struct PtlVel *tvr,
		int tnp,int *ptl2tptl,struct HaloPos *hr,float tidal_r,
		int *idx,int *inidx,int ncur){
	int i;
	int ntmp,ntmp2;
	int pindx;
	float dist,tidal_r_sqr;
	ntmp2 = inidx[ii];
	ntmp = 0;
	tidal_r_sqr = tidal_r*tidal_r;
	for(i=0;i<tnp;i++){
/*
		if(pt2h[i] == NOT_HALO_MEMBER  || pt2h[i] == ii){
*/
		if(pt2h[i] == NOT_HALO_MEMBER || inidx[pt2h[i]] >= ncur) {
			dist = (pow2(tr[i].x-hr[ii].x)+
					pow2(tr[i].y-hr[ii].y)+
					pow2(tr[i].z-hr[ii].z));
			if(dist <= tidal_r_sqr){
				r[ntmp].x = tr[i].x;
				r[ntmp].y = tr[i].y;
				r[ntmp].z = tr[i].z;
				vr[ntmp].vx = tvr[i].vx;
				vr[ntmp].vy = tvr[i].vy;
				vr[ntmp].vz = tvr[i].vz;
				ptl2tptl[ntmp] = i;
				ntmp++;
			}
			else if(pt2h[i] == ii ) pt2h[i] = NOT_HALO_MEMBER;
		}
	}
	return ntmp;
}
float find_min_tidal_r(int ii,int i,float *tidal_Rc,int *idx){
	float min_r = 999999;
	int j;
/*
	for(j=ii+1;j<mpeak;j++){
		min_r = MIN(*(tidal_Rc+i+mpeak*idx[j]),min_r);
	}
*/
	for(j=0;j<mpeak;j++){
		min_r = MIN(*(tidal_Rc+i+mpeak*j),min_r);
	}
	return min_r;
}
float find_curr_min_tidal_r(int ii,float *tidal_Rc,int i,int *idx,int ntmp){
	float min_r = 999999;
	int j;
	for(j=i+1;j<ntmp;j++){
		min_r = MIN(*(tidal_Rc+ii+mpeak*cur2thalonum[idx[j]]),min_r);
	}
	return min_r;
}
/* ̹  mhalo ο ԵǾ ִ ڸ ϰ,   
 * residual  Ǿ ִ ڵ Ѵ. */
int pseudoinclude(struct PtlPos *sr,int mhalo,int msubhalo,
		struct PtlPos *tr,int *pt2h,int tnp){
	lint ntmp,ntmp2;
	lint i,j,k;
	ntmp2 = 0;
	for(i=0;i<tnp;i++){
		if(pt2h[i] == mhalo){
			sr[ntmp2].x = tr[i].x;
			sr[ntmp2].y = tr[i].y;
			sr[ntmp2].z = tr[i].z;
 			ntmp2++;
		}
	}
	for(j=0;j<NSTEP;j++){
		/*
		i=halo2res[mhalo+mpeak*j];
		*/
		i=halo2res[mhalo+mpeak*j];
        if(i <= msubhalo) continue;
		ntmp = pvhalo_r[i];
		while(ntmp != NO_EXIT){
			sr[ntmp2].x = tr[ntmp].x;
			sr[ntmp2].y = tr[ntmp].y;
			sr[ntmp2].z = tr[ntmp].z;
			ntmp2++;
			ntmp = ppoint[ntmp];
		}
	}
	return ntmp2;
}
/*  residual  ̹ Ҵ Ǿ   ڵ ԽŲ.
 * ⼭ ߿  *ptl2tptl μ ̰ ߿ ڸ  Ϸο
 *  Ű Ѵٸ,   global  ѹ Ű ̴.
 * -1   Ѵ.  ܰ迡   ڵ ⿡ 
 * ־ Ѵ.*/
int workinclude(struct PtlPos *sr,struct PtlVel *svr,int msubhalo,
		lint *ptl2tptl,lint *pt2h,struct PtlPos *tr,struct PtlVel *tvr,
		lint tnp,int numhalo,
		struct HaloPos *hr,int halonum,float min_tidal_r){
	lint i,j,k;
	lint ntmp;
	int ntmp2;
	float dist;
	ntmp = pvhalo_r[msubhalo];
	ntmp2 = 0;
	while(ntmp != NO_EXIT){
		if(pt2h[ntmp] == NOT_HALO_MEMBER){
			dist = sqrt(pow2(hr[halonum].x-tr[ntmp].x) +
			            pow2(hr[halonum].y-tr[ntmp].y) +
			            pow2(hr[halonum].z-tr[ntmp].z) );
			if(dist < min_tidal_r){
				sr[ntmp2].x = tr[ntmp].x;
				sr[ntmp2].y = tr[ntmp].y;
				sr[ntmp2].z = tr[ntmp].z;
				svr[ntmp2].vx = tvr[ntmp].vx;
				svr[ntmp2].vy = tvr[ntmp].vy;
				svr[ntmp2].vz = tvr[ntmp].vz;
				ptl2tptl[ntmp2] = ntmp;
				ntmp2++;
			}
		}
		ntmp = ppoint[ntmp];
	}
	stillfree_starting_number = ntmp2;
	/* ⼭ stillfree  ܰ 꿡 Ե  ڸ
	 *  ִ. */
	if(stillfree != NO_EXIT){
		ntmp = stillfree;
		while(ntmp != NO_EXIT ){
			if(pt2h[ntmp] == NOT_HALO_MEMBER){
				dist = sqrt(pow2(hr[halonum].x-tr[ntmp].x) +
			            pow2(hr[halonum].y-tr[ntmp].y) +
			            pow2(hr[halonum].z-tr[ntmp].z) );
				if(dist < min_tidal_r){
					sr[ntmp2].x = tr[ntmp].x;
					sr[ntmp2].y = tr[ntmp].y;
					sr[ntmp2].z = tr[ntmp].z;
					svr[ntmp2].vx = tvr[ntmp].vx;
					svr[ntmp2].vy = tvr[ntmp].vy;
					svr[ntmp2].vz = tvr[ntmp].vz;
					ptl2tptl[ntmp2] = ntmp;
					ntmp2++;
				}
			}
			ntmp = ppoint[ntmp];
		}
	}
	/* ⼭ ̹ ԵǾ ִ ڸ Ȯϱ ؼ 
	 * Ų. */
	/*
	for(i=0;i<tnp;i++){
		if(pt2h[i] == numhalo){
			dist = sqrt(pow2(hr[halonum].x-tr[i].x) +
		            pow2(hr[halonum].y-tr[i].y) +
		            pow2(hr[halonum].z-tr[i].z) );
			if(dist < min_tidal_r){
				sr[ntmp2].x = tr[i].x;
				sr[ntmp2].y = tr[i].y;
				sr[ntmp2].z = tr[i].z;
				svr[ntmp2].vx = tvr[i].vx;
				svr[ntmp2].vy = tvr[i].vy;
				svr[ntmp2].vz = tvr[i].vz;
				ptl2tptl[ntmp2] = i;
				ntmp2++;
			}
			else {
				pt2h[i] = NOT_HALO_MEMBER;
			}
		}
	}
	*/
	return ntmp2;
}
void potential(int pnp,struct PtlPos *pr,struct PtlPos *r,
		float *potent,lint np,int *swap,int n_stride,int Parallel){
	int i,j,ndiv,nmod;
	float *tmppotent;
	MPI_Status status;
	int ready;
	int src;
	lint *pptr;
	pptr = tmppoint;
	if(Parallel == 0 || np < SERIAL_MAXIMUM){
		for(i=0;i<pnp;i++) potent[i] = 0;
		Ppotential(pnp,pr,pptr,r,potent,np,swap,n_stride,Parallel,
				selfpotential);
	}
	else{
		ndiv = np/nrank;
		nmod = np%nrank;
		/*
		for(i=1;i<nrank;i++){
			MPI_Probe(MPI_ANY_SOURCE,READY,MPI_COMM_WORLD,&status);
			src = status.MPI_SOURCE;
			MPI_Recv(&ready,1,MPI_INT,src,READY,MPI_COMM_WORLD,&status);
			ready = ParallelPotential;
			MPI_Send(&ready,1,MPI_INT,src,0,MPI_COMM_WORLD);
			MPI_Send(&pnp,1,MPI_INT,src,0,MPI_COMM_WORLD);
			MPI_Send(&ndiv,1,MPI_INT,src,0,MPI_COMM_WORLD);
			MPI_Send((pr),3*pnp,MPI_FLOAT,src,0,MPI_COMM_WORLD);
			MPI_Send((r+i*ndiv+nmod),3*ndiv,MPI_FLOAT,src,0,MPI_COMM_WORLD);
		}
		*/
		for(i=1;i<nrank;i++){
			MPI_Recv(&ready,1,MPI_INT,i,READY,MPI_COMM_WORLD,&status);
			ready = ParallelPotential;
			MPI_Send(&ready,1,MPI_INT,i,0,MPI_COMM_WORLD);
			MPI_Send(&pnp,1,MPI_INT,i,0,MPI_COMM_WORLD);
			MPI_Send(&ndiv,1,MPI_INT,i,0,MPI_COMM_WORLD);
		}
		for(i=1;i<nrank;i++){
			MPI_Send((pr),3*pnp,MPI_FLOAT,i,0,MPI_COMM_WORLD);
			MPI_Send((r+i*ndiv+nmod),3*ndiv,MPI_FLOAT,i,0,MPI_COMM_WORLD);
		}
		tmppotent = (float *)Malloc(pnp*sizeof(float),PPTR(tmppotent));
		for(i=0;i<pnp;i++) tmppotent[i] = 0;
		for(i=0;i<pnp;i++) potent[i] = 0;
		Ppotential(pnp,pr,pptr,r,tmppotent,ndiv+nmod,swap,n_stride,Parallel,
				selfpotential);
		MPI_Reduce(tmppotent,potent,pnp,MPI_FLOAT,MPI_SUM,motherrank,
				MPI_COMM_WORLD);
		if(selfpotential == 1){
			for(i=0;i<pnp;i++) potent[i]+= sqrtepsilon;
		}
		/*
		for(i=0;i<pnp;i++) potent[i] = 0;
		Ppotential(pnp,pr,pptr,r,potent,ndiv+nmod,swap,n_stride);
		for(i=1;i<nrank;i++){
			MPI_Probe(MPI_ANY_SOURCE,pnp,MPI_COMM_WORLD,&status);
			src = status.MPI_SOURCE;
			MPI_Recv(tmppotent,pnp,MPI_FLOAT,src,pnp,MPI_COMM_WORLD,
					&status);
			for(j=0;j<pnp;j++){
				potent[j] += tmppotent[j];
			}
		}
		*/
		Free(tmppotent);
	}
}
void Ppotential(int pnp,struct PtlPos *pr,lint *pptr,struct PtlPos *r,
		float *potent,lint np,int *swap,int n_stride,int Parallel,
		int selfpotential){
	float xmin,ymin,zmin,width,xmax,ymax,zmax;
	int i;
	if(np <1) return;
#ifdef PMFORCE
	sqrtepsilon = 0.9587;
#else
	sqrtepsilon = 1./sqrt(epsilon);
#endif
	xmin=2*nx;ymin=2*ny;zmin=2*nz;
	xmax=0;ymax=0;zmax=0;
	for(i=0;i<np;i++){
		xmin = MIN(xmin,r[i].x);
		ymin = MIN(ymin,r[i].y);
		zmin = MIN(zmin,r[i].z);
		xmax = MAX(xmax,r[i].x);
		ymax = MAX(ymax,r[i].y);
		zmax = MAX(zmax,r[i].z);
	}
	xmax = ceil(xmax)+1.;ymax=ceil(ymax)+1.;zmax=ceil(zmax)+1.;
	xmin = floor(xmin)-1.;ymin=floor(ymin)-1.;zmin=floor(zmin)-1.;
	width = MAX(xmax-xmin,ymax-ymin);
	width = MAX(width,zmax-zmin);
	plummerpotenttree_(&np,r,pptr,&np,&pnp,pr,potent,
			&pnp,&xmin,&ymin,&zmin,&width,
			swap,swap+n_stride,swap+2*n_stride,swap+3*n_stride,
			swap+4*n_stride,swap+5*n_stride,swap+6*n_stride,
			swap+9*n_stride,swap+12*n_stride,swap+18*n_stride,
			&n_stride,&epsilon);
		for(i=0;i<pnp;i++) potent[i]+= sqrtepsilon;
	for(i=0;i<pnp;i++) potent[i]*=potentfact;
}

/* α׷  Ϸθ  tidal ݰ ϴ ̴ */
struct PtlPos *tailpos;
float *selfpotent,*remotepotent;
double *angular;
/*  ⼭ temp  hfind   ƾ ٷ ȣҶ
 *  temporary 迭  ȣ̴.    
 *  temporary(tmppoint,swap... )  ⼭ ӽ  
 *  ؾѴ. */
float find_tidal_Rc(struct PtlPos *lr,lint lnp,struct PtlPos *sr,lint snp,
		struct HaloPos *shr,struct HaloVel *shvr,struct HaloPos *lhr,
		struct HaloVel *lhvr,int Parallel,int temp){
	int i;
	float dist,dist2,step,r2;
	float wtmp,tmp2,tmp;
	lint *pptr;
	int tailnp;
	int ntmp,mtmp;
	float results;


	if(snp == 0)
		return 0.;
	else if(lnp == 0)
		return 99999.;

	tailnp = TIDAL_STRIDE_NUM;

	dist = sqrt(pow2(shr->x-lhr->x)+pow2(shr->y-lhr->y)+pow2(shr->z-lhr->z));
	dist2 = dist*dist;
	step = dist/TIDAL_STRIDE_NUM;
	ntmp = 0;
	for(i=0;i<lnp;i++){
		r2 = pow2(lr[i].x-lhr->x)+pow2(lr[i].y-lhr->y)+pow2(lr[i].z-lhr->z);
		if(r2 < dist2) ntmp++;
	}
	if(ntmp >0){
		mtmp = (float) snp / (float) ntmp * (float) NUM_MASS;
		if(mtmp >= NUM_MASS) return dist;
		else return dist*r_tidal[mtmp];
	}
	else{
		return 99999.;
	}

}
void diff_force(int np,float *val,float step){
	int i;
	/*
	float *tmparr;
	tmparr = (float *)malloc(sizeof(float)*np);
	*/
	for(i=0;i<np-1;i++){
		/*
		tmparr[i] = (val[i+1]-val[i])/(step*com2real);
		*/
		val[i] = (val[i+1]-val[i])/com2real/step;
	}
	/*
	for(i=0;i<np-1;i++) val[i] = tmparr[i];
	free(tmparr);
	*/
}
int physical_parameters(void){
	float omepk;
	float Hsub;
	omepk = 1.-omep-omeplam;
	Hsub = sqrt(omep*pow3(amax/a)+omeplam+omepk*pow2(amax/a));
	/*    Ѵ. */
	com2real = size/hubble/rng/amax*a*1.E6*pc;
	real2com = 1./com2real;
	/*
  	pntmass = 3./8./pi/G*pow2(100.*100000.*hubble)*pow(10.,6)*pc;
  	*/
  	pntmass = 3./8./pi/G*pow2(100.*100000.*hubble)*1.E6*pc;
	pntmass = pntmass*pow3(size/hubble)/pow3(rng/nspace)*omep;
	potentfact = G/acoeff[0]*pntmass/com2real;
	/* V(r) = \dot a/ a_max *x + a/a_max * \dot x                     */
	/*      = H /(1+z) * x + u/(1+z) * \dot a                         */
	/*      = H /(1+z) * x + u/(1+z) * H * a                          */
	/*  ׷ x   comoving scale  distance ̱ 
	 *  x = x(pm) * L{size} / rng ( rng = one dimentional mesh size)
	 *  ̰, 
	 *  u = u(pm) * L{size} / rng ̾ ϴµ, ùķ̼ fda 
	 *   ̹, u(pm) ȿ rng   ִ... ڵ忡 pfact 
	 *     astep  ־ ϴµ, rng  ִ.
	 *   ̰ velocity  ̹ rng   ִٴ  Ѵ. ^^*/
	/* 10.24*h^-1/(amax/a)*100km/s/Mpc*h/pixel_size*(1+z)^1.5 
	r1kineticfact = size/hubble/rng/amax*a*100.E5*hubble*pow(amax/a,1.5); */
	/* 10.24*h^-1/(amax/a)*a*100km/s/Mpc*h*(1+z)^1.5 
	r2kineticfact = size/hubble/amax*a*a*100.E5*hubble*pow(amax/a,1.5); */
	/*
	 * X : in real scale, dX/dt : peculiar velocity in real scale
	 * dx : displacement in simulation dimension.
	 * da : simulation time step
	 * dx/da : velocity in simulation dimensions
	 * dX/dt = \dot{a} dX/da
	 *       \dot{a} = a \times H_o \times sqrt{Omega(1+z)^3+...}
	 *       dX/da = Lsize*a/amax dx/da
	 */
	r1kineticfact = size/hubble/rng/amax*a*100.E5*hubble*Hsub;
	r2kineticfact = size/hubble/amax*a*a*100.E5*hubble*Hsub;
	return 0;
}
/* α׷ i Ϸθ Ű ڵ ̾Ƴ r ,vr ϴ ̴. */
void pick_up_vr_ptl(struct PtlPos *a,struct PtlVel *va, int haloindex,
		int *pt2h,struct PtlPos *tr,struct PtlVel *tvr,int tnp){
	int i,ntmp;
	ntmp = 0;
	for(i=0;i<tnp;i++){
		if(pt2h[i] == haloindex){
			a[ntmp].x = tr[i].x;
			a[ntmp].y = tr[i].y;
			a[ntmp].z = tr[i].z;
			va[ntmp].vx = tvr[i].vx;
			va[ntmp].vy = tvr[i].vy;
			va[ntmp].vz = tvr[i].vz;
			ntmp++;
		}
	}
}
/* α׷ i Ϸθ Ű ڵ ̾Ƴ r  ϴ ̴. */
void pick_up_r_ptl(struct PtlPos *a,int haloindex,int *pt2h,
		struct PtlPos *tr,int tnp){
	int i,ntmp;
	ntmp = 0;
	for(i=0;i<tnp;i++){
		if(pt2h[i] == haloindex){
			a[ntmp].x = tr[i].x;
			a[ntmp].y = tr[i].y;
			a[ntmp].z = tr[i].z;
			ntmp++;
		}
	}
}
/*  alone_halo  potential  parameter  ٽ ľ Ѵ.
 * ׸ tree_force.mod4.f  Ӱ ľ Ѵ.
 *   struct PtlPos  ޾Ƶϼ ֵ.... */
void alone_halo(struct PtlPos *r,struct PtlVel *vr,lint np,
		struct HaloPos *hr,struct HaloVel *hvr,float xinit,float yinit,
		float zinit,lint *ptl2halonum,int Parallel,int *swap){
	lint i,nend,ntmp2;
	lint j,k;
	lint *ptrint;
	float *ptrfloat;
	float *kinetic,*penergy;
	struct PtlPos *tmpr;
	struct PtlVel *tmpvr;
	lint *pt2h;
	tmpr = (struct PtlPos *) Malloc(sizeof(struct PtlPos)*np,PPTR(tmpr));
	tmpvr = (struct PtlVel *) Malloc(sizeof(struct PtlVel)*np,PPTR(tmpvr));
	kinetic = (float *) Malloc(sizeof(float)*np,PPTR(kinetic));
	penergy = (float *) Malloc(sizeof(float)*np,PPTR(penergy));
	pt2h = ptl2halonum;

	for(i=0;i<np;i++){
		tmpr[i].x = r[i].x;
		tmpr[i].y = r[i].y;
		tmpr[i].z = r[i].z;
		tmpvr[i].vx = vr[i].vx;
		tmpvr[i].vy = vr[i].vy;
		tmpvr[i].vz = vr[i].vz;
		pt2h[i] = 0;
	}
	nend = np;
#ifdef CHECK_INFORM
	fprintf(stdout,"in alone_halo\n");
#endif
	for(i=0;i<BOUND_ITER;i++){
		/* tmpr, tmpvr   Ϸ  Ѵ */
		halo_properties(tmpr,tmpvr,nend,hr,hvr,0);
#ifdef CHECK_INFORM
	fprintf(stdout,"halo_properties in alone_halo\n");
#endif
		kinetic_energy(tmpr,tmpvr,kinetic,np,hr,hvr,0);
#ifdef CHECK_INFORM
	fprintf(stdout,"kinetic_energy in alone_halo\n");
#endif
		/* tmpr   r  ټ Ѵ.  */
		/*
		for(k=0;k<np;k++) penergy[k] = 0.;
		*/
		/* ⼭ ppoint  ׷  ִ  alone_halo ̱
		 *  ̵Ǵ  . */
/*
		potential(np,r,tmpr,penergy,nend,swap,NODE_SIZE_STRIDE,
				Parallel);
*/
#ifdef CHECK_INFORM
	fprintf(stdout,"before potential in alone_halo\n");
#endif
		potential(np,r,tmpr,penergy,nend,swap,NODE_SIZE_STRIDE,
				Parallel);
#ifdef CHECK_INFORM
	fprintf(stdout,"potential in alone_halo\n");
#endif
		for(k=0;k<np;k++) penergy[k] += kinetic[k];
		ntmp2 = 0;
		for(j=0;j<np;j++){
			if(penergy[j] < 0.){
				tmpr[ntmp2].x = r[j].x;
				tmpr[ntmp2].y = r[j].y;
				tmpr[ntmp2].z = r[j].z;
				tmpvr[ntmp2].vx = vr[j].vx;
				tmpvr[ntmp2].vy = vr[j].vy;
				tmpvr[ntmp2].vz = vr[j].vz;
				ntmp2++;
				pt2h[j] = 0;
			}
			else {
				pt2h[j] = NOT_HALO_MEMBER;
			}
		}
		nend = ntmp2;
	}
#ifdef CHECK_INFORM
	fprintf(stdout,"before freeing in alone_halo\n");
#endif
	halo_properties(tmpr,tmpvr,nend,hr,hvr,0);
	Free(kinetic);Free(tmpr);Free(tmpvr);Free(penergy);
}

void kinetic_energy(struct PtlPos *r,struct PtlVel *vr, float *kinetic,lint np,
		struct HaloPos *hr,struct HaloVel *hvr,int mhalo){
	lint i;
	float distx,disty,distz;
	float tmpvx,tmpvy,tmpvz,tmpvvx,tmpvvy,tmpvvz;
	float *ptr;
	ptr = kinetic;
	for(i=0;i<np;i++){
		distx = (r[i].x - hr[mhalo].x)*r1kineticfact;
		disty = (r[i].y - hr[mhalo].y)*r1kineticfact;
		distz = (r[i].z - hr[mhalo].z)*r1kineticfact;
		tmpvx = (vr[i].vx - hvr[mhalo].vx)*r2kineticfact;
		tmpvy = (vr[i].vy - hvr[mhalo].vy)*r2kineticfact;
		tmpvz = (vr[i].vz - hvr[mhalo].vz)*r2kineticfact;
		tmpvvx = distx+tmpvx;
		tmpvvy = disty+tmpvy;
		tmpvvz = distz+tmpvz;
		*ptr++ = tmpvvx*tmpvvx+tmpvvy*tmpvvy+tmpvvz*tmpvvz;
	}
}
void halo_properties(struct PtlPos *r,struct PtlVel *vr,
		        lint np,struct HaloPos *hr,struct HaloVel *hvr,int mhalo){
	lint i;
	hr[mhalo].x = 0;
	hr[mhalo].y = 0;
	hr[mhalo].z = 0;
	hvr[mhalo].vx = 0;
	hvr[mhalo].vy = 0;
	hvr[mhalo].vz = 0;
	for(i=0;i<np;i++){
		hr[mhalo].x += r[i].x;
		hr[mhalo].y += r[i].y;
		hr[mhalo].z += r[i].z;
		hvr[mhalo].vx += vr[i].vx;
		hvr[mhalo].vy += vr[i].vy;
		hvr[mhalo].vz += vr[i].vz;
	}
	hr[mhalo].x /= (float) np;
	hr[mhalo].y /= (float) np;
	hr[mhalo].z /= (float) np;
	hvr[mhalo].vx /= (float) np;
	hvr[mhalo].vy /= (float) np;
	hvr[mhalo].vz /= (float) np;
}
int *number;
void t_halo_properties(struct PtlPos *r,struct PtlVel *vr,lint *pt2h,
		lint np,struct HaloPos *hr,struct HaloVel *hvr){
	int i;
	struct PtlPos *tmpr;
	struct PtlVel *tmpvr;
	for(i=0;i<mpeak;i++){
		hr[i].x = 0.;
		hr[i].y = 0.;
		hr[i].z = 0.;
		hvr[i].vx = 0.;
		hvr[i].vy = 0.;
		hvr[i].vz = 0.;
	}
	tmpr = r;
	tmpvr = vr;
	number = Malloc(mpeak*sizeof(int),PPTR(number));
	for(i=0;i<mpeak;i++) number[i] = 0;
	for(i=0;i<np;i++){
		if(*(pt2h+i) != NOT_HALO_MEMBER){
			hr[*(pt2h+i)].x += tmpr->x;
			hr[*(pt2h+i)].y += tmpr->y;
			hr[*(pt2h+i)].z += tmpr->z;
			hvr[*(pt2h+i)].vx += tmpvr->vx;
			hvr[*(pt2h+i)].vy += tmpvr->vy;
			hvr[*(pt2h+i)].vz += tmpvr->vz;
			number[*(pt2h+i)]++;
		}
		tmpr++;tmpvr++;
	}
	for(i=0;i<mpeak;i++){
		if(number[i] > 0){
			hr[i].x /= number[i];
			hr[i].y /= number[i];
			hr[i].z /= number[i];
			hvr[i].vx /= number[i];
			hvr[i].vy /= number[i];
			hvr[i].vz /= number[i];
		}
		else {
			hr[i].x = 0.;
			hr[i].y = 0.;
			hr[i].z = 0.;
			hvr[i].vx = 0.;
			hvr[i].vy = 0.;
			hvr[i].vz = 0.;
		}
	}
	Free(number);
}
float piinhin3;
void find_den(struct PtlPos *r,lint np,int nxinit,int nyinit,int nzinit,
		float h){
	struct PtlPos *tmpr;
	float *tmpden;
	lint *tmpden2ptl;
	lint i,j,k,ix;
	float xp,yp,zp;
	int nxp,nyp,nzp;
	float xi,yi,zi,xf,yf,zf;
	int mxi,myi,mzi,mxf,myf,mzf;
	float gx,gy,gz,tmp2h,dist;
	float xinit,yinit,zinit;
	lint ntmp;
	/*
	piinhin3 = 1./pi/h/h/h;
	piinhin3 = 1./pi/h/h/h*magnitude*magnitude*magnitude*nspace*nspace*nspace;
	*/
	/* reason for division by magnitude^3 is to decrease the contrast
	 * due to increasing the high resolution with smaller h */
/*
	piinhin3 = 1./pi/h/h/h*nspace*nspace*nspace;
*/
	piinhin3 = 1./pi*nspace*nspace*nspace;
	tmp2h = 2.*h;
	xinit = nxinit;
	yinit = nyinit;
	zinit = nzinit;
	for(i=0;i<mx*my*mz;i++) {
		*(den+i) = 0;
		*(den2ptl+i) = 0;
	}
	tmpr = r;
	for(ix=0;ix<np;ix++){
		xp = (tmpr->x - xinit)*curmagnitude;
		yp = (tmpr->y - yinit)*curmagnitude;
		zp = (tmpr->z - zinit)*curmagnitude;
		nxp = (int) xp;
		nyp = (int) yp;
		nzp = (int) zp;
		ntmp = *(den2ptl+nxp+mx*nyp+mx*my*nzp);
		/* ⼭ +1  ִ  0   ̱ ̴. */
		*(den2ptl+nxp+mx*nyp+mx*my*nzp) = ix+1;
		*(ppoint+ix) = ntmp;
		xi = xp - tmp2h; yi = yp - tmp2h; zi = zp - tmp2h;
		xf = xp + tmp2h; yf = yp + tmp2h; zf = zp + tmp2h;
		mxi = rint(xi); myi = rint(yi); mzi = rint(zi);
		mxf = rint(xf); myf = rint(yf); mzf = rint(zf);
		for(k=mzi;k<=mzf;k++)
			for(j=myi;j<=myf;j++)
				for(i=mxi;i<=mxf;i++){
					gx = i + 0.5;
					gy = j + 0.5;
					gz = k + 0.5;
					dist = sqrt(pow2(gx-xp)+pow2(gy-yp)+pow2(gz-zp));
  					*(den+i+j*mx+k*mx*my) += w(dist,h);
				}
		tmpr++;
	}
}
float w(float dist,float h){
	float x,r;
	float sqr;
	r = dist/h;
	if(r < 1.) {
		return piinhin3*(1.-1.5*r*r+0.75*r*r*r);
	}
	else if(r < 2.) {
		sqr = 2.-r;
		return piinhin3*0.25*sqr*sqr*sqr;
	}
	else {
		return 0.;
	}
}
void find_box_size(struct PtlPos *r,lint np,float *xinit,float *yinit,
		float *zinit,float *xmax,float *ymax,float *zmax,float h){
	float min,max;
	struct PtlPos *tmpr;
	float *tmp,*tmparr;
	lint i,j;
	int *idx;
	float two_h,maxdist,tmpdist;
	int upbound;
	two_h = 2.*h;
	*xinit = nx; *xmax = -nx;
	*yinit = ny; *ymax = -ny;
	*zinit = nz; *zmax = -nz;
	for(i=0;i<np;i++){
		tmpr = r+i;
		*xinit = MIN(*xinit,tmpr->x);
		*xmax  = MAX(*xmax ,tmpr->x);
		*yinit = MIN(*yinit,tmpr->y);
		*ymax  = MAX(*ymax ,tmpr->y);
		*zinit = MIN(*zinit,tmpr->z);
		*zmax  = MAX(*zmax ,tmpr->z);
	}
	if(floor(*xinit) <= 0+nblur && ceil(*xmax) >= nx-nblur){
		idx = (int *) Malloc(sizeof(int)*np,PPTR(idx));
		tmparr = (float *) Malloc(sizeof(float)*np,PPTR(tmparr));
		tmp = tmparr;tmpr = r;
		for(i=0;i<np;i++) *(tmp++) = (tmpr++)->x;
		indexx_(&np,tmparr,idx);
		for(i=0;i<np;i++) idx[i] -= 1;
		maxdist = -10.;
		for(i=0;i<np-1;i++){
			tmpdist = tmparr[idx[i+1]] - tmparr[idx[i]];
			if(tmpdist > maxdist) {
				upbound = i;
				maxdist = tmpdist;
			}
		}
		for(i=0;i<=upbound;i++){
			r[idx[i]].x += nx;
		}
		*xinit = r[idx[upbound+1]].x;
		*xmax = r[idx[upbound]].x;
		Free(idx);Free(tmparr);
	}
	if(floor(*yinit) <= 0+nblur && ceil(*ymax) >= ny-nblur){
		idx = (int *) Malloc(sizeof(int)*np,PPTR(idx));
		tmparr = (float *) Malloc(sizeof(float)*np,PPTR(tmparr));
		tmp = tmparr;
		tmpr = r;
		for(i=0;i<np;i++) *(tmp++) = tmpr++->y;
		indexx_(&np,tmparr,idx);
		for(i=0;i<np;i++) idx[i] -= 1;
		maxdist = -10.;
		for(i=0;i<np-1;i++){
			tmpdist = tmparr[idx[i+1]] - tmparr[idx[i]];
			if(tmpdist > maxdist) {
				upbound = i;
				maxdist = tmpdist;
			}
		}
		for(i=0;i<=upbound;i++){
			r[idx[i]].y += ny;
		}
		*yinit = r[idx[upbound+1]].y;
		*ymax = r[idx[upbound]].y;
		Free(idx);Free(tmparr);
	}
	if(floor(*zinit) <= 0+nblur && ceil(*zmax) >= nz-nblur){
		idx = (int *) Malloc(sizeof(int)*np,PPTR(idx));
		tmparr = (float *) Malloc(sizeof(float)*np,PPTR(tmparr));
		tmp = tmparr;
		tmpr = r;
		for(i=0;i<np;i++) *(tmp++) = tmpr++->z;
		indexx_(&np,tmparr,idx);
		for(i=0;i<np;i++) idx[i] -= 1;
		maxdist = -10.;
		for(i=0;i<np-1;i++){
			tmpdist = tmparr[idx[i+1]] - tmparr[idx[i]];
			if(tmpdist > maxdist) {
				upbound = i;
				maxdist = tmpdist;
			}
		}
		for(i=0;i<=upbound;i++){
			r[idx[i]].z += nz;
		}
		*zinit = r[idx[upbound+1]].z;
		*zmax = r[idx[upbound]].z;
		Free(idx);Free(tmparr);
	}
}
/* pptr  Ϸ ѹ Ѿ Ѵ. */
#ifdef OLD_FOF
void fof_hfind(int np,struct PtlPos *r,lint *pptr,struct HaloPos *hr,
		int *swap,int n_stride){
	float xmin,ymin,zmin,width,xmax,ymax,zmax;
	int i;
	float b;
	lint *ph32t;
      int *connected,*ppoint;
	struct PtlPos *tmpr;
	int not_halo_member;
	not_halo_member = NOT_HALO_MEMBER;
	b = FOF_LINK*nspace;
	xmin=2*nx;ymin=2*ny;zmin=2*nz;
	xmax=0;ymax=0;zmax=0;
	for(i=0;i<np;i++){
		xmin = MIN(xmin,r[i].x);
		ymin = MIN(ymin,r[i].y);
		zmin = MIN(zmin,r[i].z);
		xmax = MAX(xmax,r[i].x);
		ymax = MAX(ymax,r[i].y);
		zmax = MAX(zmax,r[i].z);
	}
	xmax = ceil(xmax)+1.;ymax=ceil(ymax)+1.;zmax=ceil(zmax)+1.;
	xmin = floor(xmin)-1.;ymin=floor(ymin)-1.;zmin=floor(zmin)-1.;
	width = MAX(xmax-xmin,ymax-ymin);
	width = MAX(width,zmax-zmin);
	tmpr = (struct PtlPos *)Malloc(sizeof(struct PtlPos)*np,PPTR(tmpr));
    connected = (int *) Malloc(np*sizeof(int),PPTR(connected));
    ppoint = (int *) Malloc(np*sizeof(int),PPTR(ppoint));
	infof_(&np,connected,ppoint,&b,r,pptr,&np,hr,&mpeak,
			tmpr,tmppoint,&xmin,&ymin,&zmin,&width,
			swap,swap+n_stride,swap+2*n_stride,swap+3*n_stride,
			swap+4*n_stride,swap+5*n_stride,swap+6*n_stride,
			swap+9*n_stride,swap+12*n_stride,swap+18*n_stride,
			&n_stride,&not_halo_member);
    Free(connected);
    Free(ppoint);
	Free(tmpr);
}
#else
#include "./Tree/tree.h"
Box box_bound(FoFTPtlStruct *r,int nend){
	float xmin,ymin,zmin,width,xmax,ymax,zmax;
	int i,j,k;
	Box box;
	xmin=2*nx;ymin=2*ny;zmin=2*nz;
	xmax=0;ymax=0;zmax=0;
	for(i=0;i<nend;i++){
		xmin = MIN(xmin,r[i].r[0]);
		ymin = MIN(ymin,r[i].r[1]);
		zmin = MIN(zmin,r[i].r[2]);
		xmax = MAX(xmax,r[i].r[0]);
		ymax = MAX(ymax,r[i].r[1]);
		zmax = MAX(zmax,r[i].r[2]);
	}
	xmax = ceil(xmax)+1.;ymax=ceil(ymax)+1.;zmax=ceil(zmax)+1.;
	xmin = floor(xmin)-1.;ymin=floor(ymin)-1.;zmin=floor(zmin)-1.;
	width = MAX(xmax-xmin,ymax-ymin);
	width = MAX(width,zmax-zmin);
	box.x = xmin;box.y=ymin;box.z=zmin;
	box.width = width;
	return box;
}
typedef struct MaxDen{
	int num;
	FoFTPtlStruct *daughter;
}MaxDen;
float maxdenxinit,maxdenyinit,maxdenzinit;
float maxdenxmax,maxdenymax,maxdenzmax;
void fof_hfind(int np,struct PtlPos *r,lint *pptr,struct HaloPos *hr,
		int include,int Parallel){
	FoFTPtlStruct *ptl;
	FoFTPtlStruct *ptr;
	Box box;
	FoFTStruct *TREE;
	particle *linked,p;
	int nfof;
	float xmin,ymin,zmin,width,xmax,ymax,zmax;
	int i,j,k,m;
	float b;
	int not_halo_member;
	int nend,*idx;
	float *tmparr;
	int numsend,numrecv;
	int ssnend;
	int ready;
	MPI_Status cstatus;

	numsend = numrecv = 0;
	not_halo_member = NOT_HALO_MEMBER;
	b = FOF_LINK*nspace;
	ptl = (FoFTPtlStruct *) Malloc(sizeof(FoFTPtlStruct)*np,PPTR(ptl));
	linked = (particle *) Malloc(sizeof(FoFTPtlStruct)*np,PPTR(linked));
	TREE = (FoFTStruct *) Malloc(sizeof(FoFTStruct)*np,PPTR(TREE));
	tmparr = (float *) Malloc(sizeof(float)*mpeak,PPTR(tmparr));
	idx = (int *) Malloc(sizeof(int)*mpeak,PPTR(idx));
#ifdef CHECK_INFORM
		printf("now fof before sorting \n");
#endif
	{
		for(i=0;i<mpeak;i++) tmparr[i] = 0.;
		for(i=0;i<np;i++) 
			if(pptr[i] != NOT_HALO_MEMBER) tmparr[pptr[i]] ++;
			/*
		indexx_(&mpeak,tmparr,idx);
		*/
	}
	for(i=0;i<mpeak;i++){
		/*
		i = idx[k]-1;
		*/
#ifdef CHECK_INFORM
		printf("now fof with k %d  and i %d  has %f particles",k,i,
				tmparr[i]);
#endif
		nend = 0;
		box.x = xmin;box.y = ymin;box.z = zmin;
		box.width = width;
#ifdef NEVER
		p.x = hr[i].x;
		p.y = hr[i].y;
		p.z = hr[i].z;
		/* in the case of a single halo, this is problematic */
		p.x = r[haloppoint[i]].x;
		p.y = r[haloppoint[i]].y;
		p.z = r[haloppoint[i]].z;
#endif
		maxdenxinit = nx;maxdenyinit = ny;maxdenzinit = nz;
		maxdenxmax = 0;maxdenymax = 0;maxdenzmax = 0;
		if(include == 1){
			for(j=0;j<np;j++){
				if(pptr[j] == NOT_HALO_MEMBER || pptr[j] == i){
					ptl[nend].type = TYPE_PTL;
					ptl[nend].r[0] = r[j].x;
					ptl[nend].r[1] = r[j].y;
					ptl[nend].r[2] = r[j].z;
					maxdenxinit = MIN(maxdenxinit,r[j].x);
					maxdenyinit = MIN(maxdenyinit,r[j].y);
					maxdenzinit = MIN(maxdenzinit,r[j].z);
					maxdenxmax = MAX(maxdenxmax,r[j].x);
					maxdenymax = MAX(maxdenymax,r[j].y);
					maxdenzmax = MAX(maxdenzmax,r[j].z);
					ptl[nend].indx = j;
					ptl[nend].sibling = &ptl[nend+1];
					ptl[nend].included = NO;
					pptr[j] = NOT_HALO_MEMBER;
					nend ++;
				}
			}
		}
		else{
			double cx,cy,cz; 
			cx=cy=cz=0.;
			for(j=0;j<np;j++){
				if(pptr[j] == i){
					ptl[nend].type = TYPE_PTL;
					ptl[nend].r[0] = r[j].x;
					ptl[nend].r[1] = r[j].y;
					ptl[nend].r[2] = r[j].z;
					maxdenxinit = MIN(maxdenxinit,r[j].x);
					maxdenyinit = MIN(maxdenyinit,r[j].y);
					maxdenzinit = MIN(maxdenzinit,r[j].z);
					maxdenxmax = MAX(maxdenxmax,r[j].x);
					maxdenymax = MAX(maxdenymax,r[j].y);
					maxdenzmax = MAX(maxdenzmax,r[j].z);
					ptl[nend].indx = j;
					ptl[nend].sibling = &ptl[nend+1];
					ptl[nend].included = NO;
					pptr[j] = NOT_HALO_MEMBER;
					cx += r[j].x;
					cy += r[j].y;
					cz += r[j].z;
					nend ++;
				}
			}
			p.x = cx/(float)nend;
			p.y = cy/(float)nend;
			p.z = cz/(float)nend;
		}
		ptl[nend-1].sibling = NULL;
		if(nend <2) continue;
		{
			MaxDen *box;
			int boxsize;
			int nxinit,nyinit,nzinit,nxmax,nymax,nzmax;
			int nxsize,nysize,nzsize;
			int ii,mx,my,mz,numax,numptr;
			nxinit = floor(maxdenxinit); 
			nyinit = floor(maxdenyinit); 
			nzinit = floor(maxdenzinit);
			nxmax = ceil(maxdenxmax); 
			nymax = ceil(maxdenymax); 
			nzmax = ceil(maxdenzmax);
			nxsize = nxmax-nxinit+1; 
			nysize = nymax-nyinit+1; 
			nzsize = nzmax-nzinit+1;
			boxsize = nxsize*nysize*nzsize;
			box = (MaxDen *)Malloc(sizeof(MaxDen)*boxsize,PPTR(box));
			for(ii=0;ii<boxsize;ii++) {
				box[ii].num = 0;
				box[ii].daughter = NULL;
			}
			for(ii=0;ii<nend;ii++){
				FoFTPtlStruct *tmp1;
				mx = ptl[ii].r[0]-maxdenxinit; 
				my = ptl[ii].r[1]-maxdenyinit;
				mz = ptl[ii].r[2]-maxdenzinit;
				box[mx+my*nxsize+mz*nxsize*nysize].num ++;
				tmp1 = box[mx+my*nxsize+mz*nxsize*nysize].daughter;
				box[mx+my*nxsize+mz*nxsize*nysize].daughter = &ptl[ii];
				ptl[ii].sibling = tmp1;
			}
			numax = 0;
			for(ii=0;ii<boxsize;ii++){
				if(box[ii].num > numax) {
					numax = box[ii].num;
					numptr = ii;
				}
			}
			{
				double cx,cy,cz;
				FoFTPtlStruct *tmp1;
				tmp1 = box[numptr].daughter;
				p.x = p.y = p.z = 0;
				cx = cy = cz = 0;
				while(tmp1 !=NULL){
					cx += tmp1->r[0];
					cy += tmp1->r[1];
					cz += tmp1->r[2];
					tmp1 = tmp1->sibling;
				}
				p.x = cx/ box[numptr].num;
				p.y = cy/ box[numptr].num;
				p.z = cz/ box[numptr].num;
			}
			for(ii=0;ii<nend;ii++) ptl[ii].sibling = &ptl[ii+1];
			ptl[nend-1].sibling = NULL;
			Free(box);
		}
		box = box_bound(ptl,nend);
		if(Parallel == 0){
#ifdef CHECK_INFORM
			fprintf(stdout,"FoF_Make_Tree",m,Parallel);
#endif
			FoF_Make_Tree(TREE,ptl,nend,box);
#ifdef CHECK_INFORM
			fprintf(stdout,"new_fof_link",m,Parallel);
#endif
			new_fof_link(&p,b,TREE,ptl,linked);
			m = 0;
			for(j=0;j<nend;j++){
				if(ptl[j].included == YES){
					pptr[(ptl[j].indx)] = i;
					m ++;
				}
			}
#ifdef CHECK_INFORM
		fprintf(stdout,"FoF found  %d halos %d Parallel\n",m,Parallel);
		fprintf(stdout,"FoF %d calculated in %d halos\n",i,mpeak);
#endif
		}
		else {
			do {
				MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,
					MPI_ANY_TAG,MPI_COMM_WORLD,&cstatus);
#ifdef CHECK_INFORM
		fprintf(stdout,"FoF receiving signal %d from %d \n",ready,cstatus.MPI_SOURCE);
#endif
				if(ready == READY){
					int nready;
					nready =  PARALLEL_FOF_HFIND;
		       	                MPI_Send(&nready,1,MPI_INT,cstatus.MPI_SOURCE,
						0,MPI_COMM_WORLD);
					MPI_Send(&nend,1,MPI_INT,cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD);
					MPI_Send(&i,1,MPI_INT,cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD);
					MPI_Send(&b,1,MPI_FLOAT,cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD);
					MPI_Send(&p,sizeof(particle)*1,MPI_BYTE,cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD);
					MPI_Send(&box,sizeof(Box)*1,MPI_BYTE,
						cstatus.MPI_SOURCE,0,MPI_COMM_WORLD);
					MPI_Send(ptl,sizeof(FoFTPtlStruct)*nend,MPI_BYTE,
						cstatus.MPI_SOURCE,0,MPI_COMM_WORLD);
					numsend ++;
				}
				else if(ready == FoF_Report){
					FoFTPtlStruct *tmpptl;
					int ni;
					MPI_Recv(&ssnend,1,MPI_INT,
						cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD,&cstatus);
					MPI_Recv(&ni,1,MPI_INT,
						cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD,&cstatus);
					tmpptl = (FoFTPtlStruct *) Malloc(
						sizeof(FoFTPtlStruct)*ssnend,
						PPTR(tmpptl));
					MPI_Recv(tmpptl,sizeof(FoFTPtlStruct)*
						ssnend,MPI_BYTE,
						cstatus.MPI_SOURCE,0,
						MPI_COMM_WORLD,&cstatus);
					m = 0;
					for(j=0;j<ssnend;j++){
						if(tmpptl[j].included == YES){
							pptr[(tmpptl[j].indx)] 
								= ni;
							m ++;
						}
					}
					Free(tmpptl);
#ifdef CHECK_INFORM
		fprintf(stdout,"PFoF found  %d halos\n",m);
		fprintf(stdout,"PFoF %d calculated in %d halos\n",ni,mpeak);fflush(stdout);
#endif
					numrecv ++;
				}
			}while(ready != READY);
		} /* end of else */
	} /* end of for */
	if(Parallel != 0){
		int ni,ijk;
		for(j=0;j<numsend-numrecv;j++){
			MPI_Recv(&ready,1,MPI_INT,MPI_ANY_SOURCE,
				FoF_Report,MPI_COMM_WORLD, &cstatus);
			MPI_Recv(&ssnend,1,MPI_INT,
				cstatus.MPI_SOURCE,0,
				MPI_COMM_WORLD,&cstatus);
			MPI_Recv(&ni,1,MPI_INT, cstatus.MPI_SOURCE,0,
				MPI_COMM_WORLD,&cstatus);
			MPI_Recv(ptl,sizeof(FoFTPtlStruct)*
				ssnend,MPI_BYTE,
				cstatus.MPI_SOURCE,0,
				MPI_COMM_WORLD,&cstatus);
			m = 0;
			for(ijk=0;ijk<ssnend;ijk++){
				if(ptl[ijk].included == YES){
					pptr[(ptl[ijk].indx)] = ni;
					m ++;
				}
			}
#ifdef CHECK_INFORM
			fprintf(stdout,"PFoF found  %d halos\n",m);
			fprintf(stdout,"PFoF %d calculated in %d halos\n",
				ni,mpeak);
#endif
		}
	}

	Free(tmparr);Free(TREE);Free(linked);Free(ptl);
}
#endif
